////////////////////////////////////////////////////////////////////////////

#include "18F452.h"

#fuses HS,NOWDT,NOPROTECT,NOLVP,NODEBUG

#use delay(clock=38000000)

#include "GLCD_35.c"

SET_TRIS_D(0b11111111); // Entrata ADC
SET_TRIS_E(0b00000001); // RE0=INTR RE1=WR RE2=RD

/////////////////////////////////////////////////////////////////////////////

int8 Data = 0;

/////////////////////////////////////////////////////////////////////////////

void Leggi(){

  BYTE Data_E;

  output_high(PIN_E1);               // Invia impulso x ADC WI
  output_low(PIN_E1);
  delay_us(2);
  output_high(PIN_E1);

Attendi:

   Data_E=input_e();                  // Aspetta consenso ADC INT
   if(bit_test(Data_E,0)) goto Attendi;

   Data = input_d();
  }


main(){

  int8 Val[110], oldVal[110];
  int8 x, i, f, s;                    // x=pos. or.,i=ciclo, f=flag, s=sample
  int8 Vmax , Vmin, Vpp, Hz;

  char strVpp[]="Vpp";
  char strVma[]="Vma";
  char strVmi[]="Vmi";
  char strTm[]="Tms";
  char printVpp[6], printVppOld[6];
  char printVmax[6], printVmaxOld[6];
  char printVmin[6], printVminOld[6];
  char printHz[6], printHzOld[6];

  glcd_init(ON);                     // Inizializza display

  glcd_line( 0,0,18,0,ON);           // Linee orizzontali
  glcd_line( 0,63,18,63,ON);
  glcd_line( 0, 0, 0, 63, ON);       // Linee verticali
  glcd_line( 18, 0, 18, 63, ON);
  glcd_line( 127, 0, 127, 63, ON);
  glcd_text35(3,3,strVpp,ON);        // Scrivi testo
  glcd_text35(3,19,strVma,ON);
  glcd_text35(3,34,strVmi,ON);
  glcd_text35(3,50,strTm,ON);

  for (i = 22; i < 126; i+=3 ) glcd_pixel( i , 32, ON ); // Linea or. tratt.
  f = 1; x = 19;

Ciclo:

   if ( f && Data != 128){            // Sincronizza
       Leggi(); goto Ciclo;
       }else{
       f = 0;
       for ( i = 1; i < 109; i++){
       Val[i] = Data/4;               // Leggi & memorizza riga
       Leggi();}
       }

   x = 19;
   for(i = 1; i < 109; i++){            // Cancella & scrivi riga
      glcd_pixel( x , oldVal[i] , OFF);
      glcd_pixel( x ,Val[i] , ON);
      oldVal[i] = Val[i]; ++ x;
      }
      for (i = 22; i < 126; i+=3 ) glcd_pixel( i , 32, ON ); // Linea Or. Tratt.
      Vmax = 0; Vmin = 255;
      for (i = 1; i < 63 ; i++){
          if ( oldVal[i] > Vmax ) Vmax = oldVal[i];
          if ( oldVal[i] < Vmin ) Vmin = oldVal[i];
          }

      Vpp = Vmax - Vmin;
      sprintf(printVpp,"%u",Vpp);           // Scrivi Vpp
      glcd_text35(5,9,printVppOld,OFF);
      glcd_text35(5,9,printVpp,ON);
      sprintf(printVppOld,"%u",Vpp);

      sprintf(printVmax,"%u",Vmax);         // Scrivi Vmax
      glcd_text35(5,25,printVmaxOld,OFF);
      glcd_text35(5,25,printVmax,ON);
      sprintf(printVmaxOld,"%u",Vmax);

      sprintf(printVmin,"%u",Vmin);         // Scrivi Vmin
      glcd_text35(5,41,printVminOld,OFF);
      glcd_text35(5,41,printVmin,ON);
      sprintf(printVminOld,"%u",Vmin);

      s = 1;
      for( i = 1; i< 109; i++){             // Calcola & scrivi Hz
         if(oldVal[i] >30){
            if(oldVal[i] <36){
               ++s; i+=4;
               }
            }
         }
      Hz = s * 10;
      sprintf(printHz,"%u",Hz);
      glcd_text35(5,57,printHzOld,OFF);
      glcd_text35(5,57,printHz,ON);
      sprintf(printHzOld,"%u",Hz);

	  delay_ms(200); f = 1;

     goto Ciclo;
}
